/*  this value was taken from ip_icmp.h fom an RS-6000 */
#define ICMP_MINLEN           8

/* all of these exist, just under a different name */

#define ICMP_UNREACH          ICMP_DEST_UNREACH
#define ICMP_UNREACH_NET      ICMP_NET_UNREACH
#define ICMP_UNREACH_PROTOCOL ICMP_PROT_UNREACH
#define ICMP_UNREACH_PORT     ICMP_PORT_UNREACH
#define ICMP_UNREACH_HOST     ICMP_HOST_UNREACH

/* this structure was taken from an RS-6000 */
/* ip_v and ip_hl are defined elsewhere as well, but necessary here */
struct ip {
#if __BYTE_ORDER == __LITTLE_ENDIAN
        unsigned        ip_hl:4,                /* header length */
                        ip_v:4;                 /* version */
                        #endif
                        
                        /*#if __BYTE_ORDER == __BIG_ENDIAN*/
                        /*        unsigned        ip_v:4, */              /* version */
                        /*                ip_hl:4; */             /* header length */
                        /*#endif*/
                        
                                u_char  ip_tos;                 /* type of service */
                                        u_short ip_len;                 /* total length */
                                                u_short ip_id;                  /* identification */
                                                        u_short ip_off;                 /* fragment offset field */
                                                        #define IP_DF 0x4000                    /* dont fragment flag */
                                                        #define IP_MF 0x2000                    /* more fragments flag */
                                                                u_char  ip_ttl;                 /* time to live */
                                                                        u_char  ip_p;                   /* protocol */
                                                                                u_short ip_sum;                 /* checksum */
                                                                                        struct  in_addr ip_src,ip_dst;  /* source and dest address */
                                                                                        };
                                                                                        
                                                                                        
                                                                                        /* this structure was taken from an RS-6000 */
                                                                                        
                                                                                        /*
                                                                                         * Structure of an icmp header.
                                                                                          */
                                                                                          struct icmp {
                                                                                                  u_char  icmp_type;              /* type of message, see below */
                                                                                                          u_char  icmp_code;              /* type sub code */
                                                                                                                  u_short icmp_cksum;             /* ones complement cksum of struct */
                                                                                                                          union {
                                                                                                                                          u_char ih_pptr;                 /* ICMP_PARAMPROB */
                                                                                                                                                          struct in_addr ih_gwaddr;       /* ICMP_REDIRECT */
                                                                                                                                                                          struct ih_idseq {
                                                                                                                                                                                                  n_short icd_id;
                                                                                                                                                                                                                          n_short icd_seq;
                                                                                                                                                                                                                                          } ih_idseq;
                                                                                                                                                                                                                                                          int ih_void;
                                                                                                                                                                                                                                                                  } icmp_hun;
                                                                                                                                                                                                                                                                  #define icmp_pptr       icmp_hun.ih_pptr
                                                                                                                                                                                                                                                                  #define icmp_gwaddr     icmp_hun.ih_gwaddr
                                                                                                                                                                                                                                                                  #define icmp_id         icmp_hun.ih_idseq.icd_id
                                                                                                                                                                                                                                                                  #define icmp_seq        icmp_hun.ih_idseq.icd_seq
                                                                                                                                                                                                                                                                  #define icmp_void       icmp_hun.ih_void
                                                                                                                                                                                                                                                                          union {
                                                                                                                                                                                                                                                                                          struct id_ts {
                                                                                                                                                                                                                                                                                                                  n_time its_otime;
                                                                                                                                                                                                                                                                                                                                          n_time its_rtime;
                                                                                                                                                                                                                                                                                                                                                                  n_time its_ttime;
                                                                                                                                                                                                                                                                                                                                                                                  } id_ts;
                                                                                                                                                                                                                                                                                                                                                                                                  struct id_ip  {
                                                                                                                                                                                                                                                                                                                                                                                                                          struct ip idi_ip;
                                                                                                                                                                                                                                                                                                                                                                                                                                                  /* options and then 64 bits of data */
                                                                                                                                                                                                                                                                                                                                                                                                                                                                  } id_ip;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  u_long  id_mask;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  char    id_data[1];
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          } icmp_dun;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          #define icmp_otime      icmp_dun.id_ts.its_otime
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          #define icmp_rtime      icmp_dun.id_ts.its_rtime
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          #define icmp_ttime      icmp_dun.id_ts.its_ttime
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          #define icmp_ip         icmp_dun.id_ip.idi_ip
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          #define icmp_mask       icmp_dun.id_mask
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          #define icmp_data       icmp_dun.id_data
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          };
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          